# -*- coding: utf-8 -*-
"""
Le worker FTP.
Pour lui, la tâche est de récupérer un fichier sur un FTP distant
"""
from __future__ import absolute_import
import os

from everything.workers.base import Worker
from everything.constants import DONT_MOVE

class WorkerFTP(Worker):
    """
    Récupère juste les fichiers sur le FTP et les ramène dans le dossier
    local
    """
    need_ftp = True
    subfolders = ['erreur', 'traite']
    def list_files(self):
        if self.config['type'] == 'ftpget':
            return self.list_distant_files()
        if self.config['type'] == 'ftpput':
            def process_file(fname):
                if fname in self.subfolders:
                    return False
                if self.config['ftp_re'].match(fname):
                    return True
                return False

            return [fname for fname in os.listdir(self.config['dirfich']) if process_file(fname)]

    def process(self, filename):
        if self.config['type'] == 'ftpget':
            self.ftpget(filename)
            return DONT_MOVE
        if self.config['type'] == 'ftpput':
            return self.ftpput(filename)
