# -*- coding: utf-8 -*-
"""
Le garbage collector nettoie des fichiers obsolètes
"""

from __future__ import absolute_import
import os
import time

from everything.workers.base import Worker
from everything.constants import MOVE_TO_TRASH

class GarbageCollector(Worker):

    def list_files(self):
        """
        Liste les fichiers à traiter
        """
        age_fichier = self.config.get('age_fichier', 0)
        if age_fichier == 0:
            self.logger.error(u"age_fichier doit être positionné pour que le 'Garbage Collector' fonctionne")
            return []
        now = time.time()
        flist = os.listdir(self.config['dirfich'])
        for special in self.subfolders:
            if special in flist:
                flist.remove(special)
        final_list = []
        for fname in flist:
            if self.config['fname_re'].match(fname):
                # Check file ctime and mtime
                full_fname = os.path.join(self.config['dirfich'], fname)
                last_of_the_times = max(os.path.getmtime(full_fname), os.path.getctime(full_fname))
                if last_of_the_times < now - age_fichier * 3600: # age_fichier est en heures
                    final_list.append(fname)
        return final_list

    def process(self, filename):
        return MOVE_TO_TRASH
