# -*- coding: utf-8 -*-
"""
Le worker samba peut lire/ecrire des fichiers sur un partage samba
"""


from __future__ import absolute_import
import os
import re


# Nos propres Imports
from everything.workers.base import Worker
from everything.constants import DONT_MOVE

class WorkerSamba(Worker):
    """
    Récupère juste les fichiers sur le Samba et les ramène dans le dossier
    local
    """
    need_samba = True
    subfolders = ['erreur', 'traite']
    def list_files(self):
        fname_re = self.config['fname_re']
        if fname_re is None:
            fname_re = re.compile('.*')
        if self.config["type"] == "smbget":
            return self.list_samba_distant_files()
        if self.config["type"] == "smbput":
            files = []
            for fname in os.listdir(self.config["dirfich"]):
                if not fname in self.subfolders and fname_re.match(fname):
                    files.append(fname)
            return files

    def process(self, filename):
        if self.config["type"] == "smbget":
            self.smbget(filename)
            return DONT_MOVE
        if self.config["type"] == "smbput":
            return self.smbput(filename)
