# -*- coding: utf-8 -*-
"""
Le worker tuple. Il s'agit d'une class à surclasser
lorsqu'on veut traiter non pas des fichiers en entrée
mais une liste d'objets
"""

from __future__ import absolute_import
from everything.workers.base import Worker

class WorkerTuple(Worker):
    """
    Ce worker ne prend pas en entrée une liste de fichiers
    mais une liste de tuples qui représentent par exemple
    des informations récupérées en BDD
    """
    def run(self, count = None):
        objects = self.list_objects()
        if not objects:
            self.logger.debug(u"Aucun object à traiter")
            return
        allobjects = len(objects)
        if count is not None:
            objects = objects[:count]
        self.logger.info(u"Traitement de %s objets sur %s", len(objects), allobjects)
        for processed_object in objects:
            oid = processed_object[0]
            self.logger.debug(u"%s - Traitement de l'objet", oid)
            self.process(processed_object)
    def list_objects(self):
        """
        Liste les objets à traiter
        """
        return []
